/*
 * Graphisc.c
 *
 *  Created on: Mar 1, 2012
 *      Author: Mateusz
 */

#include "Graphisc.h"
void SendSPI( char a)
 {
	 unsigned char cont;
	 cont=8;
	 GPIO_SetBits(SPI,SCK);
	 for(;cont>0;cont--)
	 {
		 GPIO_ResetBits(SPI,SCK);
		 if((0x80&a)==0)
		 {
			 GPIO_ResetBits(SPI,DIN);
		 }
		 else
		 {
			 GPIO_SetBits(SPI,DIN);
		 }
		 GPIO_SetBits(SPI,SCK);
		 a=a<<1;
	 }
	 GPIO_SetBits(SPI,SCE);
 }

 void WriteComand(char comand)
 {
	 GPIO_ResetBits(SPI,SCE);
	 GPIO_ResetBits(SPI,SCK);
	 GPIO_ResetBits(SPI,DIN);
	 SendSPI(comand);
 }

 void WriteData(char comand)
 {
 	 GPIO_ResetBits(SPI,SCE);
 	 GPIO_ResetBits(SPI,SCK);
 	 GPIO_SetBits(SPI,DIN);
 	 SendSPI(comand);
  }

 void LCDClear(char color)
 {
	 WriteComand(PASET);
	 WriteData(0);
	 WriteData(131);
	 WriteComand(CASET);
	 WriteData(0);
	 WriteData(131);
	 WriteComand(RAMWR);
	 char i,j;
	 for(i=0;i<132;i++)
	 {
		 for(j=0;j<132;j++)
		 {
			 WriteData(color);
		 }
	 }
	 WriteComand(DISON);
 }

 void lcdInit()
 {
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_InitStruct.GPIO_Pin = SCK|DIN|RES|SCE;
	GPIO_InitStruct.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStruct.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(SPI, &GPIO_InitStruct);
	GPIO_SetBits(SPI,SCE);
	GPIO_SetBits(SPI,SCK);
	GPIO_SetBits(SPI,DIN);
	GPIO_ResetBits(SPI,RES);
	GPIO_SetBits(SPI,RES);
	WriteComand(SLPOUT);
	WriteComand(COLMOD);
	WriteData(0x02);
	WriteComand(MADCTL);
	WriteData(0x50);
	WriteComand(DISON);
}

void LCDContrastSet(char a)
{
	WriteComand(SETCON);
	WriteData(a);
}

void drawBox(uint8 x, uint8 y,uint8 sizeX,uint8 sizeY,uint8 color)
{
	WriteComand(PASET);
	WriteData(x);
	WriteData(x+sizeX-1);
	WriteComand(CASET);
	WriteData(y);
	WriteData(y+sizeY-1);
	WriteComand(RAMWR);
	char i,j;
	for(i=0;i<sizeX;i++)
	{
		for(j=0;j<sizeY;j++)
		{
			WriteData(color);
		}
	}


}

void drawBall(uint8 x, uint8 y, uint8 color,uint8 background)
{
	WriteComand(PASET);
	WriteData(x);
	WriteData(x+4);
	WriteComand(CASET);
	WriteData(y);
	WriteData(y+4);
	WriteComand(RAMWR);
	char i,j;
	for(i=0;i<5;i++)
	{
		if(i==0 || i==4)
			WriteData(background);
		else
			WriteData(color);
	}
	for(i=0;i<3;i++)
	{
		for(j=0;j<5;j++)
		{
			WriteData(color);
		}
	}
	for(i=0;i<5;i++)
	{
		if(i==0 || i==4)
			WriteData(background);
		else
			WriteData(color);
	}
}

